# Copyright © 2021 Arrikto Inc.  All Rights Reserved.

"""Kale SDK.

This script defines a pipeline with a looping statement.
"""

import random

from kale.sdk import step, pipeline


@step(name="generate")
def generate():
    gen = random.sample(range(0, 20), 2)
    return gen


@step(name="printer")
def squared(value):
    value = float(value)
    print(value * value)


@step(name="printer2")
def printer(value):
    value = int(value)
    print(value)


@step(name="printer3")
def mult(value1, value2, value3):
    value1 = float(value1)
    value2 = float(value2)
    value3 = float(value3)
    print(value1 * value2 * value3)


@step(name="printer4")
def hello():
    print("Hello!")


const_list = [2, 3]


@pipeline(name="loop", experiment="kale-tutorial")
def looping_pipeline(arg_list=[0, 1]):
    res = generate()
    for x in res:
        squared(x)
        for i in arg_list:
            printer(i)
            for j in const_list:
                mult(x, i, j)
        for z in [4, 5]:
            hello()


if __name__ == "__main__":
    looping_pipeline()
